part of jaguar.generator.parser.route;

/// Detects interceptors on a given method or class
List<InterceptorCreatorFunc> detectWrappers(
    ClassElement upper, Element element) {
  final ret = <InterceptorCreatorFunc>[];

  for (ElementAnnotation annot in element.metadata) {
    final DartObject v = annot.computeConstantValue();
    if (isWrap.isExactlyType(v.type)) {
      v
          .getField('interceptors')
          .toListValue()
          .map((obj) => new InterceptorCreatorFunc(
              obj.type.element.name, obj.type.element is MethodElement))
          .forEach(ret.add);
    } else if (isWrapOne.isExactlyType(v.type)) {
      DartObjectImpl f = v.getField('interceptor');
      ret.add(new InterceptorCreatorFunc(
          f.type.element.name, f.type.element is MethodElement));
    }
  }

  return ret;
}
